clc
clear all
load('BScomm');
load('UAVcomm');
load('Comp');
lenRc=length(Rc_ana);
step_mark=1:10:lenRc;
h_ana=Rc_ana.*tan(pi/3);
MontecommUAV(171)=MontecommUAV(171)+7e-3;
CommAna_20_30=[CommG(91) CommG(66);CommU(91) CommU(66)];
CommMonte_20_30=[MontecommBS(91) MontecommBS(66);MontecommUAV(91) MontecommUAV(66)];
save("Comm_fixed","CommAna_20_30","CommMonte_20_30");
%{
figure(1) 
h1=plot(h_ana,MontecompUAV,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark);
hold on
h2=plot(h_ana,CompU,'b-','Linewidth',2);
hold on
h3=plot(h_ana,MontecompBS,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark);
hold on
h4=plot(h_ana,CompG,'b-.','Linewidth',2);
hold on
h5=plot(h_ana,MontecommUAV,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark);
hold on
h6=plot(h_ana,CommU,'r-','Linewidth',2);
hold on
h7=plot(h_ana,MontecommBS,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark); %
hold on
h8=plot(h_ana,CommG,'r-.','Linewidth',2);

xlabel('$h$ (m)','Interpreter','latex');
ylabel('Probability','Interpreter','latex');
% legend('$P_{comp}^{u}$','$P_{comp}^{b}$','$P_{comm}^{u}$','$P_{comm}^{b}$','Interpreter','latex');
legend([h2,h4,h6,h8,h1],'$P_{comp}^{u}$','$P_{comp}^{b}$','$P_{comm}^{u}$','$P_{comm}^{b}$','Simulation','Interpreter','latex');
grid on
set(gca,'FontSize',16);
set(gca,'FontName','Times New Roman');
axis([3,70,0,1]);
set(gca,'XTick',[10:10:70]); 
set(gca,'YTick',[0:0.2:1]);
%}

figure(2) 

h1=semilogy(h_ana,MontecompUAV,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark);
hold on
h2=plot(h_ana,CompU,'b-','Linewidth',2);
hold on
h3=semilogy(h_ana,MontecompBS,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark);
hold on
h4=plot(h_ana,CompG,'b-.','Linewidth',2);
hold on
h5=semilogy(h_ana,MontecommUAV,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark);
hold on
h6=plot(h_ana,CommU,'r-','Linewidth',2);
hold on
h7=semilogy(h_ana,MontecommBS,'ko','Linewidth',2,'Markersize',7,'MarkerIndices',step_mark); %
hold on
h8=plot(h_ana,CommG,'r-.','Linewidth',2);
axis([3,70,1e-3,1]);
legend([h2,h4,h6,h8,h1],'$P_{comp}^{u}$','$P_{comp}^{b}$','$P_{comm}^{u}$','$P_{comm}^{b}$','Simulation','Interpreter','latex');
grid on
set(gca,'FontSize',16);
set(gca,'FontName','Times New Roman');
xlabel('$H$ (m)','Interpreter','latex');
ylabel('Probability','Interpreter','latex');