clear all
clc
p=1; % user transmit power
aBS = 4;
N0 = 10.^(-4); % noise
targetSNR=10^(-1);

Rc_ana=2:0.2:40; % coverage radius
h_ana=Rc_ana.*tan(pi/3);
lenRc=length(Rc_ana);
MontecommBS=zeros(1,lenRc);
MontecommUAV=zeros(1,lenRc);
MontecompBS=zeros(1,lenRc);
MontecompUAV=zeros(1,lenRc);
CommU=zeros(1,lenRc);
CommG=zeros(1,lenRc);
CompG=zeros(1,lenRc);
CompU=zeros(1,lenRc);

rat_ana=1e-1:1e-3:1;
lenRat=length(rat_ana);
% ratioUAV=1; % the ratio of users associated with UAV
% ratioUAV=0;
rat=0.3;

fi=N0/p*targetSNR;
target=0.7;
l=10;
% l_ana=21:1:40;
xBS=0; % location of ground BS
yBS=0;
xUAV=l.*sin(pi./3); % location of UAV
yUAV=l.*cos(pi./3);
lenL=length(l); % length of trajectory
deadline2=10^(-3);
a1=-1;
a2=2;
b1=3.5;
b2=1;
a3=25;
b3=1;
% tBS=10^(-6);
tBS=10^(-5);
dBS=0.1;
% tUAV=2*10^(-5);
tUAV=10^(-4);
dUAV=0.2;
VM_k=1:1:10000;
TcompUAV=tUAV.*(1+dUAV).^(VM_k-1);%不同负载情况下的平均计算时延，避免重复计算
TcompBS=tBS.*(1+dBS).^(VM_k-1);
maxBS=floor(log(deadline2/tBS)/log(1+dBS)+1);
optBS=round(1/log(1+dBS));
maxBS=min(maxBS,optBS);
maxUAV=floor(log(deadline2/tUAV)/log(1+dUAV)+1);
optUAV=round(1/log(1+dUAV));
maxUAV=min(maxUAV,optUAV);
UEdensity=1e-1; % user density 
load1=1:maxBS;
load2=1:maxUAV;
load0=1:100;

REPEAT=1e3;


CommBStem=zeros(1,REPEAT);
CommUAVtem=zeros(1,REPEAT);

delt=2/aBS;

% Monte Carlo for Communication：count all points in a realization
for i = 1:lenRc
    rUAV=Rc_ana(i); % the coverage radius
    h=h_ana(i);
    areaUAV=pi*rUAV^2;
    countUAV=REPEAT;
    countBS=REPEAT;
    CompBStem=zeros(1,REPEAT);
    CompUAVtem=zeros(1,REPEAT);
    for f = 1:REPEAT
    numUE=poissrnd(areaUAV*UEdensity); % HPPP realization
    SNR_UAV = zeros(1,numUE);
    SNR_BS = zeros(1,numUE);
    if numUE==0 % exception handling to avoid NaN
        numUE=1;
    end
    association=zeros(numUE,2);
    for j=1:numUE
        if rand(1)<=rat
            association(j,1)=1; % UAV computing
        else
            association(j,2)=1; % BS computing
        end
    end
    if numUE>1
       Nload=sum(association);
    else
       Nload=association;
    end
%     if Nload(1)>0
%     CompUAVtem(f)=(TcompUAV(Nload(1))<=deadline2);
%     else
%     CompUAVtem(f)=1;
%     end
%     if Nload(2)>0
%     CompBStem(f)=(TcompBS(Nload(2))<=deadline2);
%     else
%     CompBStem(f)=1;
%     end
if Nload(1)>0
   CompUAVtem(f)=(Nload(1)<=maxUAV);
else
   countUAV=countUAV-1;
end
if Nload(2)>0
CompBStem(f)=(Nload(2)<=maxBS);
else
   countBS=countBS-1;
end

    the=2*pi*(rand(numUE,1));
    rad=rUAV*sqrt(rand(numUE,1));
    [xUE,yUE] = pol2cart(the,rad);
    horizonUAV=sqrt(xUE.^2+yUE.^2);
    xUE=xUE+xUAV;
    yUE=yUE+yUAV;
    dBS = sqrt((xUE-xBS).^2+(yUE-yBS).^2);
    dUAV = sqrt(horizonUAV.^2+h.^2); 
    seedUE=rand(1); % random association
    if seedUE<ratioUAV
        K=a3.*exp(b3.*atan(h./horizonUAV)); %Rician fading
        mu = sqrt( K./(2.*(K+1))); 
        su = sqrt( 1./(2.*(K+1)));
        aUAV=a1./(1+a2.*exp(-b2.*atan(h./horizonUAV)))+b1;
        ri = ( su.*randn(numUE,1) + mu ) + 1i.*( su.*randn(numUE,1) + mu );
        H = abs(ri);
        SNR_UAV = H.*p.*dUAV.^(-aUAV)./N0;     
    else
        H=exprnd(1,[numUE,1]);
        SNR_BS = H.*p.*dBS.^(-aBS)./N0;   
    end
    CommBStem(f)=sum(SNR_BS>=targetSNR)/numUE;
    CommUAVtem(f)=sum(SNR_UAV>=targetSNR)/numUE;
    end
MontecommBS(i) = mean(CommBStem);
MontecommUAV(i) = mean(CommUAVtem);
MontecompBS(i)= sum(CompBStem)/countBS;
MontecompUAV(i)= sum(CompUAVtem)/countUAV;
end

% Analytical for Communication
for i=1:lenRc
rUAV=Rc_ana(i); % the coverage radius
h=h_ana(i);
succ1=((1-rat).*UEdensity.*pi.*rUAV.^2).^load1./factorial(load1).*exp(-(1-rat).*UEdensity.*pi.*rUAV.^2);
succ2=(rat.*UEdensity.*pi.*rUAV.^2).^load2./factorial(load2).*exp(-rat.*UEdensity.*pi.*rUAV.^2);
tota1=((1-rat).*UEdensity.*pi.*rUAV.^2).^load0 ./factorial(load0) .*exp(-(1-rat).*UEdensity.*pi.*rUAV.^2);
tota2=(rat.*UEdensity.*pi.*rUAV.^2).^load0 ./factorial(load0) .*exp(-rat.*UEdensity.*pi.*rUAV.^2);
CompG(i)=sum(succ1)./sum(tota1);
CompU(i)=sum(succ2)./sum(tota2);
f=@(x) 2.*x.*marcumq(sqrt(2.*(a3.*exp(b3.*atan(h./x)))),sqrt(2.*(1+(a3.*exp(b3.*atan(h./x)))).*fi.*(x.^2+h.^2).^((a1./(1+a2.*exp(-b2.*atan(h./x)))+b1)./2)))./rUAV.^2;
CommU(i)=integral(f,0,rUAV);
if l>=rUAV
low_bound=l-rUAV;
upper_bound=l+rUAV;
f1=@(x) exp(-fi.*x.^aBS).*(pi.*x-2.*x.*asin(((x.^2-rUAV.^2+l.^2)./(2.*l))./x));
p1=integral(f1,low_bound,upper_bound);
f2=@(x) exp(-fi.*x.^aBS).*(-x./sqrt(x.^2-((x.^2-rUAV.^2+l.^2)./(2.*l)).^2).*(x.^2./l-((x.^2-rUAV.^2+l.^2)./(2.*l))));
p2=integral(f2,low_bound,upper_bound);
f3=@(x) exp(-fi.*x.^aBS).*(-x./l.*sqrt(x.^2-((x.^2-rUAV.^2+l.^2)./(2.*l)).^2));
p3=integral(f3,low_bound,upper_bound);
f4=@(x) exp(-fi.*x.^aBS).*(-((x.^2-rUAV.^2+l.^2)./(2.*l))./sqrt(x.^2-((x.^2-rUAV.^2+l.^2)./(2.*l)).^2)).*(x-x.*((x.^2-rUAV.^2+l.^2)./(2.*l))./l);
p4=integral(f4,low_bound,upper_bound);
f5=@(x) exp(-fi.*x.^aBS).*(rUAV.^2.*x./l./sqrt(rUAV.^2-((l.^2-x.^2+rUAV.^2)./(2.*l)).^2));
p5=integral(f5,low_bound,upper_bound);
f6=@(x) exp(-fi.*x.^aBS).*(x./l.*sqrt(rUAV.^2-((l.^2-x.^2+rUAV.^2)./(2.*l)).^2));
p6=integral(f6,low_bound,upper_bound);
f7=@(x) exp(-fi.*x.^aBS).*(-x.*((l.^2-x.^2+rUAV.^2)./(2.*l)).^2./l./sqrt(rUAV.^2-((l.^2-x.^2+rUAV.^2)./(2.*l)).^2));
p7=integral(f7,low_bound,upper_bound);
CommG(i)=(p1+p2+p3+p4+p5+p6+p7)./(pi.*rUAV.^2);
else
low_bound=rUAV-l;
upper_bound=l+rUAV;
f0=@(x) exp(-fi.*x.^aBS).*2.*x./rUAV.^2;
p0=integral(f0,0,low_bound);
f1=@(x) exp(-fi.*x.^aBS).*(pi.*x-2.*x.*asin(((x.^2-rUAV.^2+l.^2)./(2.*l))./x));
p1=integral(f1,low_bound,upper_bound);
f2=@(x) exp(-fi.*x.^aBS).*(-x./sqrt(x.^2-((x.^2-rUAV.^2+l.^2)./(2.*l)).^2).*(x.^2./l-((x.^2-rUAV.^2+l.^2)./(2.*l))));
p2=integral(f2,low_bound,upper_bound);
f3=@(x) exp(-fi.*x.^aBS).*(-x./l.*sqrt(x.^2-((x.^2-rUAV.^2+l.^2)./(2.*l)).^2));
p3=integral(f3,low_bound,upper_bound);
f4=@(x) exp(-fi.*x.^aBS).*(-((x.^2-rUAV.^2+l.^2)./(2.*l))./sqrt(x.^2-((x.^2-rUAV.^2+l.^2)./(2.*l)).^2)).*(x-x.*((x.^2-rUAV.^2+l.^2)./(2.*l))./l);
p4=integral(f4,low_bound,upper_bound);
f5=@(x) exp(-fi.*x.^aBS).*(rUAV.^2.*x./l./sqrt(rUAV.^2-((l.^2-x.^2+rUAV.^2)./(2.*l)).^2));
p5=integral(f5,low_bound,upper_bound);
f6=@(x) exp(-fi.*x.^aBS).*(x./l.*sqrt(rUAV.^2-((l.^2-x.^2+rUAV.^2)./(2.*l)).^2));
p6=integral(f6,low_bound,upper_bound);
f7=@(x) exp(-fi.*x.^aBS).*(-x.*((l.^2-x.^2+rUAV.^2)./(2.*l)).^2./l./sqrt(rUAV.^2-((l.^2-x.^2+rUAV.^2)./(2.*l)).^2));
p7=integral(f7,low_bound,upper_bound);
CommG(i)=p0+(p1+p2+p3+p4+p5+p6+p7)./(pi.*rUAV.^2);
end
end

step_mark=1:1:lenRc;

figure(1) % ratioUAV=0
set(gca,'FontSize',16);
set(gca,'FontName','Times New Roman');
plot(Rc_ana,MontecommBS,'ro','Markersize',8,'MarkerIndices',step_mark); %
hold on
plot(Rc_ana,CommG,'k-','Linewidth',2);
xlabel('$R$','Interpreter','latex');
ylabel('Successful communication probability','Interpreter','latex');
save('BScomm','Rc_ana','MontecommBS','CommG');

figure(2) % ratioUAV=1
set(gca,'FontSize',16);
set(gca,'FontName','Times New Roman');
plot(Rc_ana,MontecommUAV,'ro','Markersize',8,'MarkerIndices',step_mark);
hold on
plot(Rc_ana,CommU,'k-','Linewidth',2);
xlabel('R','Interpreter','latex');
ylabel('Successful communication probability','Interpreter','latex');
error=sum(abs(MontecommUAV-CommU));
save('UAVcomm','Rc_ana','MontecommUAV','CommU');








