% golden section search
clear all
clc
l_ana = 60:10:120;
lenL = length(l_ana);
maxit= 20;
iterRecord = zeros(lenL,maxit);
epsilon=1e-5;
tau = 0.618;
for i=1:lenL
    l = l_ana(i);
    a=0;
    b=1;
    R0 = IniUAV(l);
    iterRecord(i,:) = R0.*ones(1,maxit);
    w1 = b - tau * (b - a);
    w2 = a + tau * (b - a);
    for j = 2:maxit
        R1 = OptR(l,R0,w1);
        R2 = OptR(l,R0,w2);
        if  R1< R2
            a=w1;
            w1=w2;
            w2 = a + tau * (b - a);
            iterRecord(i,j:maxit) = R2;
        elseif R1 > R2
            b=w2;
            w2=w1;
            w1 = b - tau * (b - a);
            iterRecord(i,j:maxit) = R1;
        else
            a=w2;
            w1 = b - tau * (b - a);
            w2 = a + tau * (b - a);
        end
        if(abs(b - a) < epsilon)
            break;
        end
    end
end
figure(1)
plot(iterRecord(1,:));
save('Convergence','l_ana','iterRecord');
