clear all
clc; 

% Set up problem
% 60.0	70.0	80.0	90.0	100.0	110.0	120.0
% 76.4	71.3	63.199	57.0	53.2	51.0	49.7  Proposed
%75.2	71.018	62.627	55.40	52.54	49.54	46.78 种群10迭代40
%71.84  67.81   59.83   51.78   49.78   46.42   44.79 种群5迭代40
%71.23  64.91   56.41   50.83   49.47   45.97   43.62 种群10迭代20
objFun = @ObjFunc;   % Minimize this function

xLow = [10;0]; % lower bound on the search space
xUpp = [120;1]; % upper bound on the search space
x0 = [46;0.5];  % No initial guess

% options.alpha = 0.4;  % Optimum: weight on current search direction
% options.beta = 0.9;   % Optimum: weight on local best search direction
% options.gamma = 0.9;  % Optimum: weight on global best search direction

options.alpha = 1;  % weight on current search direction
options.beta = 0.4;   % weight on local best search direction
options.gamma = 0.3;  % weight on global best search direction

options.nPopulation = 10;
% options.nPopulation = 5;
% options.maxIter = 40;
options.maxIter = 20;

options.plotFun = @plotBowl;  % Plots progress


%%%% Solve
[xBest, fBest, info, dataLog] = PSO(objFun, x0, xLow, xUpp, options);

%%%% Analysis
figure(101); clf;
plotPsoHistory(info);
% save('PSO80_20','xBest','fBest','info','dataLog');


