% Case study 1
% user: HPPP, fixed density
% horizontal trajectory: circle
clear all
clc
% ------ Trajectory Parameter ------
xBS=70;
yBS=60;
zBS=0;
N=64;
sitaTra=0:2*pi/N:2*pi;
T = pi/16;
t = T:T:2*pi;
xUAV = 75-60.*cos(t/3);
yUAV = 75+60.*sin(t);
lenTra=length(yUAV);
zUAV=zeros(1,lenTra);
zzUAV=zeros(1,lenTra);
ltest=sqrt((xUAV-xBS).^2+(yUAV-yBS).^2);
UEdensity1=1e-3:2e-4:40e-4;
UEdensity2=1e-3:1e-3:16e-3;
UEdensity=[UEdensity1 UEdensity2];

x_window=110;
y_window=140;
lenx1=50;
leny1=80;
lenx2=8+x_window-lenx1;
leny2=15+y_window-leny1;
numUE=random('Poisson',mean(UEdensity1)*lenx1*leny1);
xUE1=rand(1,numUE).*lenx1;
yUE1=y_window-leny1+rand(1,numUE).*leny1;
zUE1=zeros(1,numUE);
numUE=random('Poisson',mean(UEdensity2)*lenx2*leny2);
xUE2=lenx1+rand(1,numUE).*lenx2;
yUE2=rand(1,numUE).*leny2;
zUE2=zeros(1,numUE);
xUE=[xUE1 xUE2];
yUE=[yUE1 yUE2];
zUE=[zUE1 zUE2];
beta=zeros(1,lenTra);
% ----- Resource Parameter ------
for i=1:lenTra
    Opt=OptObtain(UEdensity(i),ltest(i));
    zUAV(i)=Opt(1);
    beta(i)=Opt(2);
end

figure(1)
h1=plot3(xUE,yUE,zUE,'bx','MarkerFaceColor','b','MarkerSize',4);
hold on
h2=plot3(xBS,yBS,zBS,'ro','MarkerFaceColor','r','MarkerSize',6);
hold on
h3=plot3(xUAV,yUAV,zUAV,'k--');
hold on
h4=plot3(xUAV,yUAV,zzUAV,'k--');
grid on
legend([h1,h2,h3,h4],'user','BS','UAV horizontal trajectory','UAV 3D trajectory','Interpreter','latex');
xlabel('$\beta$','Interpreter','latex');
ylabel('$P_{comp}$','Interpreter','latex');
set(gca,'FontSize',16);
set(gca,'FontName','Times New Roman');
xlabel('$x$(m)','Interpreter','latex');
ylabel('$y$(m)','Interpreter','latex');
zlabel('$z$(m)','Interpreter','latex');
set(gca,'FontSize',16);
set(gca,'FontName','Times New Roman');

